<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDetailedPersonFilter ArrayType
 * @subpackage Arrays
 */
class ArrayOfDetailedPersonFilter extends AbstractStructArrayBase
{
    /**
     * The DetailedPersonFilter
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DetailedPersonFilter[]
     */
    public $DetailedPersonFilter;
    /**
     * Constructor method for ArrayOfDetailedPersonFilter
     * @uses ArrayOfDetailedPersonFilter::setDetailedPersonFilter()
     * @param \StructType\DetailedPersonFilter[] $detailedPersonFilter
     */
    public function __construct(array $detailedPersonFilter = array())
    {
        $this
            ->setDetailedPersonFilter($detailedPersonFilter);
    }
    /**
     * Get DetailedPersonFilter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DetailedPersonFilter[]|null
     */
    public function getDetailedPersonFilter()
    {
        return isset($this->DetailedPersonFilter) ? $this->DetailedPersonFilter : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDetailedPersonFilter method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDetailedPersonFilter method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDetailedPersonFilterForArrayConstraintsFromSetDetailedPersonFilter(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDetailedPersonFilterDetailedPersonFilterItem) {
            // validation for constraint: itemType
            if (!$arrayOfDetailedPersonFilterDetailedPersonFilterItem instanceof \StructType\DetailedPersonFilter) {
                $invalidValues[] = is_object($arrayOfDetailedPersonFilterDetailedPersonFilterItem) ? get_class($arrayOfDetailedPersonFilterDetailedPersonFilterItem) : sprintf('%s(%s)', gettype($arrayOfDetailedPersonFilterDetailedPersonFilterItem), var_export($arrayOfDetailedPersonFilterDetailedPersonFilterItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DetailedPersonFilter property can only contain items of type \StructType\DetailedPersonFilter, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DetailedPersonFilter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DetailedPersonFilter[] $detailedPersonFilter
     * @return \ArrayType\ArrayOfDetailedPersonFilter
     */
    public function setDetailedPersonFilter(array $detailedPersonFilter = array())
    {
        // validation for constraint: array
        if ('' !== ($detailedPersonFilterArrayErrorMessage = self::validateDetailedPersonFilterForArrayConstraintsFromSetDetailedPersonFilter($detailedPersonFilter))) {
            throw new \InvalidArgumentException($detailedPersonFilterArrayErrorMessage, __LINE__);
        }
        if (is_null($detailedPersonFilter) || (is_array($detailedPersonFilter) && empty($detailedPersonFilter))) {
            unset($this->DetailedPersonFilter);
        } else {
            $this->DetailedPersonFilter = $detailedPersonFilter;
        }
        return $this;
    }
    /**
     * Add item to DetailedPersonFilter value
     * @throws \InvalidArgumentException
     * @param \StructType\DetailedPersonFilter $item
     * @return \ArrayType\ArrayOfDetailedPersonFilter
     */
    public function addToDetailedPersonFilter(\StructType\DetailedPersonFilter $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DetailedPersonFilter) {
            throw new \InvalidArgumentException(sprintf('The DetailedPersonFilter property can only contain items of type \StructType\DetailedPersonFilter, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DetailedPersonFilter[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DetailedPersonFilter|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DetailedPersonFilter|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DetailedPersonFilter|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DetailedPersonFilter|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DetailedPersonFilter|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DetailedPersonFilter
     */
    public function getAttributeName()
    {
        return 'DetailedPersonFilter';
    }
}
