<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStartingFromPriceFile ArrayType
 * @subpackage Arrays
 */
class ArrayOfStartingFromPriceFile extends AbstractStructArrayBase
{
    /**
     * The StartingFromPriceFile
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StartingFromPriceFile[]
     */
    public $StartingFromPriceFile;
    /**
     * Constructor method for ArrayOfStartingFromPriceFile
     * @uses ArrayOfStartingFromPriceFile::setStartingFromPriceFile()
     * @param \StructType\StartingFromPriceFile[] $startingFromPriceFile
     */
    public function __construct(array $startingFromPriceFile = array())
    {
        $this
            ->setStartingFromPriceFile($startingFromPriceFile);
    }
    /**
     * Get StartingFromPriceFile value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StartingFromPriceFile[]|null
     */
    public function getStartingFromPriceFile()
    {
        return isset($this->StartingFromPriceFile) ? $this->StartingFromPriceFile : null;
    }
    /**
     * This method is responsible for validating the values passed to the setStartingFromPriceFile method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStartingFromPriceFile method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStartingFromPriceFileForArrayConstraintsFromSetStartingFromPriceFile(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfStartingFromPriceFileStartingFromPriceFileItem) {
            // validation for constraint: itemType
            if (!$arrayOfStartingFromPriceFileStartingFromPriceFileItem instanceof \StructType\StartingFromPriceFile) {
                $invalidValues[] = is_object($arrayOfStartingFromPriceFileStartingFromPriceFileItem) ? get_class($arrayOfStartingFromPriceFileStartingFromPriceFileItem) : sprintf('%s(%s)', gettype($arrayOfStartingFromPriceFileStartingFromPriceFileItem), var_export($arrayOfStartingFromPriceFileStartingFromPriceFileItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The StartingFromPriceFile property can only contain items of type \StructType\StartingFromPriceFile, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set StartingFromPriceFile value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\StartingFromPriceFile[] $startingFromPriceFile
     * @return \ArrayType\ArrayOfStartingFromPriceFile
     */
    public function setStartingFromPriceFile(array $startingFromPriceFile = array())
    {
        // validation for constraint: array
        if ('' !== ($startingFromPriceFileArrayErrorMessage = self::validateStartingFromPriceFileForArrayConstraintsFromSetStartingFromPriceFile($startingFromPriceFile))) {
            throw new \InvalidArgumentException($startingFromPriceFileArrayErrorMessage, __LINE__);
        }
        if (is_null($startingFromPriceFile) || (is_array($startingFromPriceFile) && empty($startingFromPriceFile))) {
            unset($this->StartingFromPriceFile);
        } else {
            $this->StartingFromPriceFile = $startingFromPriceFile;
        }
        return $this;
    }
    /**
     * Add item to StartingFromPriceFile value
     * @throws \InvalidArgumentException
     * @param \StructType\StartingFromPriceFile $item
     * @return \ArrayType\ArrayOfStartingFromPriceFile
     */
    public function addToStartingFromPriceFile(\StructType\StartingFromPriceFile $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StartingFromPriceFile) {
            throw new \InvalidArgumentException(sprintf('The StartingFromPriceFile property can only contain items of type \StructType\StartingFromPriceFile, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->StartingFromPriceFile[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\StartingFromPriceFile|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\StartingFromPriceFile|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\StartingFromPriceFile|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\StartingFromPriceFile|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\StartingFromPriceFile|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StartingFromPriceFile
     */
    public function getAttributeName()
    {
        return 'StartingFromPriceFile';
    }
}
