<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Solution StructType
 * @subpackage Structs
 */
class Solution extends AbstractStructBase
{
    /**
     * The offerList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfOffer
     */
    public $offerList;
    /**
     * The establishmentList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfEstablishment
     */
    public $establishmentList;
    /**
     * The productList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfProduct
     */
    public $productList;
    /**
     * The offerSortByThematic
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\OfferSortByThematic
     */
    public $offerSortByThematic;
    /**
     * Constructor method for Solution
     * @uses Solution::setOfferList()
     * @uses Solution::setEstablishmentList()
     * @uses Solution::setProductList()
     * @uses Solution::setOfferSortByThematic()
     * @param \ArrayType\ArrayOfOffer $offerList
     * @param \ArrayType\ArrayOfEstablishment $establishmentList
     * @param \ArrayType\ArrayOfProduct $productList
     * @param \StructType\OfferSortByThematic $offerSortByThematic
     */
    public function __construct(\ArrayType\ArrayOfOffer $offerList = null, \ArrayType\ArrayOfEstablishment $establishmentList = null, \ArrayType\ArrayOfProduct $productList = null, \StructType\OfferSortByThematic $offerSortByThematic = null)
    {
        $this
            ->setOfferList($offerList)
            ->setEstablishmentList($establishmentList)
            ->setProductList($productList)
            ->setOfferSortByThematic($offerSortByThematic);
    }
    /**
     * Get offerList value
     * @return \ArrayType\ArrayOfOffer|null
     */
    public function getOfferList()
    {
        return $this->offerList;
    }
    /**
     * Set offerList value
     * @param \ArrayType\ArrayOfOffer $offerList
     * @return \StructType\Solution
     */
    public function setOfferList(\ArrayType\ArrayOfOffer $offerList = null)
    {
        $this->offerList = $offerList;
        return $this;
    }
    /**
     * Get establishmentList value
     * @return \ArrayType\ArrayOfEstablishment|null
     */
    public function getEstablishmentList()
    {
        return $this->establishmentList;
    }
    /**
     * Set establishmentList value
     * @param \ArrayType\ArrayOfEstablishment $establishmentList
     * @return \StructType\Solution
     */
    public function setEstablishmentList(\ArrayType\ArrayOfEstablishment $establishmentList = null)
    {
        $this->establishmentList = $establishmentList;
        return $this;
    }
    /**
     * Get productList value
     * @return \ArrayType\ArrayOfProduct|null
     */
    public function getProductList()
    {
        return $this->productList;
    }
    /**
     * Set productList value
     * @param \ArrayType\ArrayOfProduct $productList
     * @return \StructType\Solution
     */
    public function setProductList(\ArrayType\ArrayOfProduct $productList = null)
    {
        $this->productList = $productList;
        return $this;
    }
    /**
     * Get offerSortByThematic value
     * @return \StructType\OfferSortByThematic|null
     */
    public function getOfferSortByThematic()
    {
        return $this->offerSortByThematic;
    }
    /**
     * Set offerSortByThematic value
     * @param \StructType\OfferSortByThematic $offerSortByThematic
     * @return \StructType\Solution
     */
    public function setOfferSortByThematic(\StructType\OfferSortByThematic $offerSortByThematic = null)
    {
        $this->offerSortByThematic = $offerSortByThematic;
        return $this;
    }
}
